<?php

namespace App\Models\Materials;

use App\Models\Commons\Category;
use App\Models\Commons\File;
use App\Models\Commons\Tag;
use App\Models\Qualitys\Lot;
use App\Traits\Auditable;
use App\Traits\BelongsToTenant;
use App\Traits\ModelTrait;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

/**
 * @mixin IdeHelperMaterial
 */
class Material extends Model
{
    use Auditable, BelongsToTenant, ModelTrait, SoftDeletes;

    protected $fillable = [
        'tenant_id',
        'category_id',
        'name',
        'item_name',
        'specification',
        'material_code',
        'material_type',
        'unit',
        'is_inspection',
        'search_tag',
        'remarks',
        'attributes',
        'options',
        'created_by',
        'updated_by',
        'is_active',
    ];

    protected $casts = [
        'attributes' => 'array',
        'options' => 'array',
        'is_active' => 'boolean',
    ];

    protected $hidden = [
        'deleted_at',
    ];

    // 카테고리
    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    // 자재 입고 내역
    public function receipts()
    {
        return $this->hasMany(MaterialReceipt::class, 'material_id');
    }

    // 로트 관리
    public function lots()
    {
        return $this->hasMany(Lot::class, 'material_id');
    }

    // 파일 목록 (N:M, 폴리모픽)
    public function files()
    {
        return $this->morphMany(File::class, 'fileable');
    }

    // 태그 목록 (N:M, 폴리모픽)
    public function tags()
    {
        return $this->morphToMany(Tag::class, 'taggable');
    }
}
